# Script for imaging 


import os
import re
import glob




## THE QA2 reducer may leave you some notes 


## very line rich dataset
## will try to do standard cont subtraction 
## but the PI will need to take some care


# 4 SPW - 0,1,2,3

thesteps = []
step_title = {0: 'Continuum image',
              1: 'UV cont sub',
              2: 'CH3OH',
              3: 'CH3CN',
              4: 'Makes fits'}


try:
  print 'List of steps to be executed ...', mysteps
  thesteps = mysteps
except:
  print 'global variable mysteps not set.'
if (thesteps==[]):
  thesteps = range(0,len(step_title))
  print 'Executing all steps: ', thesteps


print '### Running clean  ###'

visname='uid___A002_X867766_Xa7.ms.split.cal'
cell='0.15arcsec'  # usually 5-8 smaller than beam
imagesize=256
souname='IRAS16293_B4'

# the PI should check carfully if these are suitable or use
# a possible alternative method of removing the continuum 

## the UVcont sub doesnt look to produce the best images possible
## please check this carefully 

spwcont='0:0~210;320~400;500~860;980~1020;1240~1350;1550~1640;1780~2220;2340~2360;2460~2700;2840~3200;3400~3450;3750~3839,1:0~9;130~220;290~315;375~425;660~785;925~945;970~1020;1115~1200;1570~1640;2100~2140;2680~2770;2980~3020,2:0~470;820~1020;1420~1460;1680~1760;1980~2200;2430~2660;2960~3400;3690~3839,3:70~140;300~350;420~460;960~1100;1350~1390;1520~1580;2010~2090;2185~2350;2865~2890;3000~3060;3250~3625'

# continuum

mystep = 0
if(mystep in thesteps):
  print 'Step ', mystep, step_title[mystep]

  
  #os.system('rm -rf '+souname+'.cont.*')
  # clean continuum
  tclean(vis=visname,
            spw = spwcont,
            imagename = souname+'.cont',
            field='3',  # set for the source 
            cell=cell,
            imsize=imagesize,
            specmode='mfs',
            outframe='LSRK',
            niter=500,  
            weighting='briggs',
            robust=0.5,
	    threshold='0.002Jy',
	    usemask='auto-multithresh',
       	    lownoisethreshold=3.0,
       	    noisethreshold=3.0,
	    pbcor=True,
            interactive=True)


mystep = 1
if(mystep in thesteps):
  print 'Step ', mystep, step_title[mystep]

### cont sub
  os.system('rm -rf '+visname+'.contsub')

  uvcontsub(vis=visname,
    field='3',
    fitspw=spwcont,
    spw = '0,1,2,3')
    #combine='spw') # optional - sometimes produces better results if you have few channels but are close in frequency 



# CH3OH line
mystep = 2
if(mystep in thesteps):
  print 'Step ', mystep, step_title[mystep]

  os.system('rm -rf '+souname+'.CH3OH.*')

  tclean(vis=visname+'.contsub',
            spw = '0',  # new ones as wide cal band gone
            imagename = souname+'.CH3OH',
            field='0',  # only this field now 
            cell=cell,
            imsize=imagesize,
            specmode='cube',
            outframe='LSRK',
            niter=500,
            width='240kHz',
            interactive=False,
            weighting='briggs',
            robust=0.5)



# CH3CN
mystep = 3
if(mystep in thesteps):
  print 'Step ', mystep, step_title[mystep]


  # clean again here
  os.system('rm -rf '+souname+'.CH3CN.*')

  tclean(vis=visname+'.contsub',
            spw = '2',  # new ones as wide cal band gone
            imagename = souname+'.CH3CN',
            field='0',  # only this field now 
            cell=cell,
            imsize=imagesize,
            specmode='cube',
            outframe='LSRK',
            niter=500,
            width='240kHz',
            interactive=False,
            weighting='briggs',
            robust=0.5)

# for the other lines in the data one can repeat the
# above command and change the spw and the rest frequency


# fits
mystep = 4
if(mystep in thesteps):
  print 'Step ', mystep, step_title[mystep]



  # use glob
  fitslist=glob.glob('*image')
  for imagefits in fitslist:
    myimagebase=imagefits[:-6]
    print myimagebase
    
    exportfits(imagename=myimagebase+'.image', fitsimage=myimagebase+'.image.fits') # export the corrected image
    exportfits(imagename=myimagebase+'.pb', fitsimage=myimagebase+'.pb.fits') # export the PB image
